<?php

/**
 * deducidos_noley actions.
 *
 * @package    nomina
 * @subpackage deducidos_noley
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class deducidos_noleyActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_DED_NOLEY_V',
        'NO_DATOS_FUNCIONARIO_V',
        'NO_CONCEP_NOMINA',
        'NO_PERIODO',
        'NO_TIPO_PERIODO',
        'INTERCEROS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'id_tipo_doc' => 'NO_DED_NOLEY_V',
            'num_doc' => 'NO_DED_NOLEY_V'
        ),
        'NO_CONCEP_NOMINA' =>
        array(
            'id_concep_nomina' => 'NO_DED_NOLEY_V'
        ),
        'NO_PERIODO' =>
        array(
            'id_periodo' => 'NO_DED_NOLEY_V'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'id_tipo_periodo' => 'NO_PERIODO'
        ),
        'INTERCEROS_V, LEFT' =>
        array(
            'id_mae_ter' => 'NO_DED_NOLEY_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_DED_NOLEY_V' =>
        array(
            'id_ded_noley' => 'id_ded_noley',
            'id_periodo' => 'id_periodo',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'id_concep_nomina' => 'id_concep_nomina',
            'num_cuotas' => 'num_cuotas',
            'cuotas_desc' => 'cuotas_desc',
            'valor_cuota' => 'valor_cuota',
            'porcentaje_cuota' => 'porcentaje_cuota',
            'saldo' => 'saldo',
            'fecha_crea' => 'fecha_crea',
            'fecha_mod' => 'fecha_mod',
            'id_periodo_ini' => 'id_periodo_ini',
            'id_periodo_fin' => 'id_periodo_fin',
            'id_mae_ter' => 'id_mae_ter',
            'estado' => 'estado',
            'fecha_anu' => 'fecha_anu',
            'motivo_anu' => 'motivo_anu',
            'periodo_ini' => 'periodo_ini',
            'periodo_fin' => 'periodo_fin',
            'doc_soporte' => 'doc_soporte',
            'fecha_soporte' => 'fecha_soporte'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'nombre_completo' => 'nombre_completo'
        ),
        'NO_CONCEP_NOMINA' =>
        array(
            'codigo' => 'codigo_concepto',
            'descripcion' => 'descripcion_concepto',
            'codigo,||, - ,||,descripcion' => 'completo_concepto'
        ),
        'NO_PERIODO' =>
        array(
            'id_meses' => 'id_meses',
            'id_anhos' => 'id_anhos'
        ),
        'NO_TIPO_PERIODO' =>
        array(
            'descripcion' => 'descripcion_periodo'
        ),
        'INTERCEROS_V' =>
        array(
            'num_doc' => 'documento_acree',
            'razon_soc' => 'nombre_acree'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_DED_NOLEY_V' => array(
            'id_ded_noley,a' => array('!=' => array(-1)),
            'id_ded_noley,b' => array('=' => array('id_ded_noley')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'num_doc' => array('=' => array('num_doc')),
            'id_concep_nomina' => array('=' => array('id_concep_nomina')),
            'id_periodo' => array('=' => array('id_periodo_filtro')),
            'id_mae_ter' => array('=' => array('id_mae_ter')),
            'doc_soporte' => array('LIKE' => array('doc_soporte')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'num_doc', 'id_ded_noley'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_ded_noley'; //identificador de la tabla
    protected $id_names = array('id_ded_noley'); //llave primaria
    protected $field_names = array('id_periodo', 'id_tipo_doc', 'num_doc', 'id_concep_nomina', 'num_cuotas', 'cuotas_desc', 'valor_cuota'
        , 'porcentaje_cuota', 'saldo', 'fecha_crea', 'fecha_mod', 'id_periodo_ini', 'id_periodo_fin',
        'id_mae_ter', 'estado', 'fecha_anu', 'motivo_anu', 'total_ded', 'doc_soporte', 'fecha_soporte'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_DED_NOLEY'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
    protected $actions_remove = false; //true - Accion remove en vez de anular
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD
    protected $campo_fecha_sistema = array(
        'fecha_mod'
    );


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_ded_noley'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $request['fecha_crea'] = CN_TABLE::fechaSistema();

            $fecha_anu = CN_TABLE::fechaSistema();

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();

            $logger->info("Entro a Add");

            if (isset($request['valor_cuota'])) {
                $request['saldo'] = $request['valor_cuota'] * $request['num_cuotas'];
            } else {
                $request['saldo'] = null;
            }
            $request['id_periodo_ini'] = $request['id_periodo'];
            $request['id_periodo_fin'] = $request['id_periodo'];

            //Total de los deducidos segun cuotas o valor ingresado - 20190411
            if (!isset($request['total_ded']) || $request['total_ded'] <= 0) {
                $request['total_ded'] = $request['saldo'];
            }

            $id_tipo_doc = $request['id_tipo_doc'];
            $num_doc = $request['num_doc'];
            $id_concep_nomina = $request['id_concep_nomina'];

            //Actualizar fecha y motivo anulacion - 20130522
            $sql = <<<EOD
update no_ded_noley set estado = 0, 
    fecha_anu = '$fecha_anu',
    motivo_anu = 'Anulación por nuevo registro por concepto.'    
    where id_concep_nomina = $id_concep_nomina 
        and id_tipo_doc = $id_tipo_doc 
            and num_doc = '$num_doc' and estado = 1
EOD;

            $this->conn->execute($sql);
        }

        //accion update
        if ($Action == "UPDATE") {


            $id_ded_noley = $request['id_ded_noley'];
            $sql = <<<EOD
SELECT
total_ded
FROM no_ded_noley 
where
id_ded_noley = $id_ded_noley 
EOD;

            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql, true);

            if (count($records) > 0) {
                $request['total_ded'] = $records[0]['total_ded'];
            } else {
                $request['total_ded'] = 0;
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            $request['fecha_anu'] = CN_TABLE::fechaSistema();
            $id_ded_noley = $request['id_ded_noley'];

            //tomar valor de total, para que no cambie - 20190415
            $sql = <<<EOD
select * from NO_DED_NOLEY 
    where id_ded_noley = $id_ded_noley 
EOD;
            $records = CN_TABLE::executeSQL($sql);
            $request['total_ded'] = $records[0]['total_ded'];
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {


            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_deducido = $list_data_post[0]['id_ded_noley'];
                $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];
                $num_doc = $list_data_post[0]['num_doc'];
                $fecha_cre = $list_data_post[0]['fecha_crea'];
                $id_periodo = $list_data_post[0]['id_periodo'];
                $id_concep_nomina = $list_data_post[0]['id_concep_nomina'];
                $valor_cuota = $list_data_post[0]['valor_cuota'];
                $porcentaje_cuota = $list_data_post[0]['porcentaje_cuota'];
                $num_cuotas = $list_data_post[0]['num_cuotas'];



                /*
                 * NOM-116 <-> Conceptos que aplica_desc_adic_vac - 20150505
                 */
                $sql = <<<EOD
SELECT * FROM NO_CONCEP_NOMINA WHERE id_concep_nomina = $id_concep_nomina 
EOD;
                $conceptos = CN_TABLE::executeSQL($sql);
                $aplica_desc_adic_vac = $conceptos[0]['aplica_desc_adic_vac'];
                $deduc_adic_vacac = false;

                if ($aplica_desc_adic_vac) {

                    $logger->info("Concepto aplica desc adic vacac id_concep_nomina - " . $id_concep_nomina);

                    $sql = <<<EOD
select 
novac.*,
tipvac.tiempo_liqui
from no_novedad_vac novac
left join no_tipo_nov_vac tipvac
on novac.id_tipo_nov_vac = tipvac.id_tipo_nov_vac
where 
novac.id_periodo = $id_periodo and tipvac.tiempo_liqui = 1 and tipvac.operador = 1
and novac.id_tipo_doc = $id_tipo_doc and novac.num_doc = $num_doc 
EOD;
                    $nov_vac = CN_TABLE::executeSQL($sql);

                    if (count($nov_vac) > 0) {

                        $deduc_adic_vacac = true;
                        $fecha_ini_vac = $nov_vac[0]['fecha_ini'];
                        $fecha_fin_vac = $nov_vac[0]['fecha_fin'];
                    }
                }


                $sql = <<<EOD
            SELECT * FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                $id_anhos = $results[0]['id_anhos'];
                $id_meses = $results[0]['id_meses'];
                $id_periodo = $results[0]['id_periodo'];
                $id_tipo_periodo = $results[0]['id_tipo_periodo'];

                $sql = <<<EOD
            SELECT * FROM NO_TIPO_PERIODO WHERE ID_TIPO_PERIODO = $id_tipo_periodo 
EOD;
                $results = CN_TABLE::executeSQL($sql);

                $num_dias = $results[0]['no_dias_mes'];

                if ($valor_cuota != "") {

                    $logger->info("Entro a valor_cuota - " . $valor_cuota);

                    $sql = "select * from NO_CONCEPTO_PERIODO tab0 where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo=$id_periodo and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";
                    $results = CN_TABLE::executeSQL($sql);

                    /**
                     * el porcentaje si viene se actualiza en la tabla para liquidar
                     */
                    if ($porcentaje_cuota != "") {
                        //deja el mismo valor
                        $porcentaje_cuota = $porcentaje_cuota;
                    } else {
                        $porcentaje_cuota = 'null';
                    }

                    if (count($results) > 0) {

                        $sql = "update NO_CONCEPTO_PERIODO tab0 set tab0.valor = $valor_cuota, tab0.porcentaje = $porcentaje_cuota

            where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo=$id_periodo and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                        $this->conn->execute($sql);
                    } else {


                        $sql = <<<EOD
            INSERT INTO NO_CONCEPTO_PERIODO (ID_ANHOS,ID_MESES,PERIODO,ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,VALOR,NUM_DIAS,PORCENTAJE)
                VALUES($id_anhos,$id_meses,$id_periodo,$id_tipo_doc,$num_doc,$id_concep_nomina,to_date('$fecha_cre','YYYY-MM-DD'),last_day(to_date('$fecha_cre','YYYY-MM-DD')),$valor_cuota,$num_dias,$porcentaje_cuota)
EOD;
                        $this->conn->execute($sql);
                    }
                } else {

                    $sql = "select * from NO_CONCEPTO_PERIODO tab0 where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo=$id_periodo and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";
                    $results = CN_TABLE::executeSQL($sql);

                    if (count($results) > 0) {

                        $sql = "update NO_CONCEPTO_PERIODO tab0 set tab0.porcentaje = $porcentaje_cuota

            where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo=$id_periodo and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                        $this->conn->execute($sql);
                    } else {

                        $sql = <<<EOD
            INSERT INTO NO_CONCEPTO_PERIODO (ID_ANHOS,ID_MESES,PERIODO,ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,PORCENTAJE,NUM_DIAS)
                VALUES($id_anhos,$id_meses,$id_periodo,$id_tipo_doc,$num_doc,$id_concep_nomina,to_date('$fecha_cre','YYYY-MM-DD'),last_day(to_date('$fecha_cre','YYYY-MM-DD')),$porcentaje_cuota,$num_dias)
EOD;

                        $this->conn->execute($sql);
                    }
                }


                /**
                 * NOM-116 <-> Valida numero de cuotas y que se deba descontar - 20150505
                 */
                if ($num_cuotas >= 2 && $deduc_adic_vacac) {

                    /*
                     * CREO EL REGISTRO 
                     */
                    if ($valor_cuota != "") {

                        $logger->info("Entro a valor_cuota - " . $valor_cuota);

                        /**
                         * el porcentaje si viene se actualiza en la tabla para liquidar
                         */
                        if ($porcentaje_cuota != "") {
                            //deja el mismo valor
                            $porcentaje_cuota = $porcentaje_cuota;
                        } else {
                            $porcentaje_cuota = 'null';
                        }

                        $sql = <<<EOD
INSERT INTO NO_CONCEPTO_PERIODO (ID_ANHOS,ID_MESES,PERIODO,ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,VALOR,NUM_DIAS,PORCENTAJE)
    VALUES($id_anhos,$id_meses,$id_periodo,$id_tipo_doc,$num_doc,$id_concep_nomina,
        to_date('$fecha_ini_vac','YYYY-MM-DD'),to_date('$fecha_fin_vac','YYYY-MM-DD'),$valor_cuota,$num_dias,$porcentaje_cuota)
EOD;
                        $this->conn->execute($sql);
                    } else {

                        $sql = <<<EOD
INSERT INTO NO_CONCEPTO_PERIODO (ID_ANHOS,ID_MESES,PERIODO,ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,PORCENTAJE,NUM_DIAS)
    VALUES($id_anhos,$id_meses,$id_periodo,$id_tipo_doc,$num_doc,$id_concep_nomina,
        to_date('$fecha_ini_vac','YYYY-MM-DD'),to_date('$fecha_fin_vac','YYYY-MM-DD'),$porcentaje_cuota,$num_dias)
EOD;

                        $this->conn->execute($sql);
                    }
                } else {

                    $logger->info("No hay mas cuotas para descontar " . $num_cuotas);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $id_deducido = $list_data_post[0]['id_ded_noley'];
            $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];
            $num_doc = $list_data_post[0]['num_doc'];
            $id_periodo = $list_data_post[0]['id_periodo'];
            $id_concep_nomina = $list_data_post[0]['id_concep_nomina'];
            $valor_cuota = $request['valor_cuota'];

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_ded_noley = $request['id_ded_noley'];
                $estado = $request['estado'];

                //Incidente #9755, activar e inactivar, segun el periodo activo - 20181116
                //Se controla que es inactivar ya que no tiene fehca anu ni motivo de anulacion
                //Si activo
                if ($estado == 1) {

                    //Actualizar la fecha - 20190412
                    $sql = <<<EOD
update no_ded_noley set fecha_activa = sysdate 
    where id_ded_noley = $id_ded_noley 
EOD;

                    $this->conn->execute($sql);

                    $sql = "select * from NO_CONCEPTO_PERIODO tab0 
                            where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo in (SELECT id_periodo FROM no_periodo where activo = 1)
                            and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";
                    $results = CN_TABLE::executeSQL($sql);

                    if (count($results) > 0) {

                        $sql = "update NO_CONCEPTO_PERIODO tab0 set tab0.valor = '$valor_cuota'
            where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo in (SELECT id_periodo FROM no_periodo where activo = 1) 
                            and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                        $this->conn->execute($sql);
                    } else {

                        $sql = <<<EOD
            INSERT INTO NO_CONCEPTO_PERIODO (ID_ANHOS,ID_MESES,PERIODO,ID_TIPO_DOC,NUM_DOC,ID_CONCEP_NOMINA,FECHA_DESDE,FECHA_HASTA,PORCENTAJE,VALOR,NUM_DIAS)
                VALUES((SELECT max(id_anhos) FROM no_periodo where activo = 1),(SELECT max(id_meses) FROM no_periodo where activo = 1),(SELECT max(id_periodo) FROM no_periodo where activo = 1),
                    $id_tipo_doc,$num_doc,$id_concep_nomina,(SELECT max(fecha_ini) FROM no_periodo where activo = 1),last_day((SELECT max(fecha_fin) FROM no_periodo where activo = 1)),
                        null, '$valor_cuota', 30)
EOD;

                        $this->conn->execute($sql);
                    }
                } else {
                    //Si es Inactivo
                    $sql = "update NO_CONCEPTO_PERIODO tab0 set tab0.valor = 0
            where tab0.id_concep_nomina = $id_concep_nomina and tab0.periodo in (SELECT id_periodo FROM no_periodo where activo = 1)  
                            and tab0.id_tipo_doc = $id_tipo_doc and tab0.num_doc = $num_doc";

                    $this->conn->execute($sql);

                    //Actualizar la fecha - 20190412
                    $sql = <<<EOD
update no_ded_noley set fecha_inactiva = sysdate 
    where id_ded_noley = $id_ded_noley 
EOD;

                    $this->conn->execute($sql);
                }


                //COMMIT DE TODAS LAS TRANSACCIONE
                $this->conn->commit();
                $this->logMessage("COMMIT DE TODAS LAS TRANSACCIONES");
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
                $this->logMessage("ROLLBACK DE TODAS LAS TRANSACCIONES");
                $this->logMessage($e->getMessage());
            }
        }

        //accion remove
        if ($Action == "REMOVE") {

            $id_periodo = $request['periodo_actual'];
            $id_tipo_doc = $request['id_tipo_doc'];
            $num_doc = $request['num_doc'];
            $id_concep_nomina = $request['id_concep_nomina'];

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $sql = <<<EOD
delete from NO_CONCEPTO_PERIODO tab0 
where tab0.id_concep_nomina = $id_concep_nomina 
    and tab0.periodo = $id_periodo and tab0.id_tipo_doc = $id_tipo_doc 
        and tab0.num_doc = $num_doc
EOD;

                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        return $request;
    }

}
